package cn.iocoder.yudao.framework.common.thealgorithms.bitmanipulation;

///**
// * Find Non Repeating Number
// * @author Bama Charan Chhandogi (https://github.com/BamaCharanChhandogi)
// */
//
//public final class NonRepeatingNumberFinder {
//    private NonRepeatingNumberFinder() {
//    }
//
//    public static int findNonRepeatingNumber(int[] arr) {
//        int result = 0;
//        for (int num : arr) {
//            result ^= num;
//        }
//        return result;
//    }
//}


/**
 * 查找不重复的数字
 * @作者 Bama Charan Chhandogi (https://github.com/BamaCharanChhandogi)
 */

public final class NonRepeatingNumberFinder {
    private NonRepeatingNumberFinder() {
    }

    // 查找数组中不重复的数字
    public static int findNonRepeatingNumber(int[] arr) {
        int result = 0;
        // 遍历数组中的每个数字
        for (int num : arr) {
            // 对每个数字进行异或运算，最终结果即为不重复的数字
            result ^= num;
        }
        // 返回结果
        return result;
    }
}
